AbstractTypeVisitor8 (Java SE 26 & JDK 26)
Description: declaration: module: java.compiler, package: javax.lang.model.util, class: AbstractTypeVisitor8
Keywords: javax.lang.model.util.AbstractTypeVisitor8 class

# Class AbstractTypeVisitor8<R,P>

java.lang.Object
javax.lang.model.util.AbstractTypeVisitor6<R,P>
javax.lang.model.util.AbstractTypeVisitor7<R,P>
javax.lang.model.util.AbstractTypeVisitor8<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `TypeVisitor<R,P>`

Direct Known Subclasses:
  `AbstractTypeVisitor9`

@SupportedSourceVersion(RELEASE_8) public abstract class AbstractTypeVisitor8<R,P> extends AbstractTypeVisitor7<R,P>
A skeletal visitor of types with default behavior appropriate for the `RELEASE_8` source version.

Since:
  1.8
See Also:
  - Compatibility note for subclasses
  - `AbstractTypeVisitor6`
  - `AbstractTypeVisitor7`
  - `AbstractTypeVisitor9`
  - `AbstractTypeVisitor14`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AbstractTypeVisitor8()`
  Constructor for concrete subclasses to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract R`
  `visitIntersection(IntersectionType t, P p)`
  Visits an intersection type.

  ### Methods declared in class AbstractTypeVisitor7

  `visitUnion`
  Modifier and Type
  Method
  Description
  `abstract R`
  `visitUnion(UnionType t, P p)`
  Visits a `UnionType` in a manner defined by a subclass.

  ### Methods declared in class AbstractTypeVisitor6

  `visit, visit, visitUnknown`
  Modifier and Type
  Method
  Description
  `final R`
  `visit(TypeMirror t)`
  Visits any type mirror as if by passing itself to that type mirror's `accept` method and passing `null` for the additional parameter.
  `final R`
  `visit(TypeMirror t, P p)`
  Visits any type mirror as if by passing itself to that type mirror's `accept` method.
  `R`
  `visitUnknown(TypeMirror t, P p)`
  Visits an unknown kind of type.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

  ### Methods declared in interface TypeVisitor

  `visitArray, visitDeclared, visitError, visitExecutable, visitNoType, visitNull, visitPrimitive, visitTypeVariable, visitWildcard`
  Modifier and Type
  Method
  Description
  `R`
  `visitArray(ArrayType t, P p)`
  Visits an array type.
  `R`
  `visitDeclared(DeclaredType t, P p)`
  Visits a declared type.
  `R`
  `visitError(ErrorType t, P p)`
  Visits an error type.
  `R`
  `visitExecutable(ExecutableType t, P p)`
  Visits an executable type.
  `R`
  `visitNoType(NoType t, P p)`
  Visits a `NoType` instance.
  `R`
  `visitNull(NullType t, P p)`
  Visits the null type.
  `R`
  `visitPrimitive(PrimitiveType t, P p)`
  Visits a primitive type.
  `R`
  `visitTypeVariable(TypeVariable t, P p)`
  Visits a type variable.
  `R`
  `visitWildcard(WildcardType t, P p)`
  Visits a wildcard type.

- ## Constructor Details

  - ### AbstractTypeVisitor8

    protected AbstractTypeVisitor8()
    Constructor for concrete subclasses to call.

- ## Method Details

  - ### visitIntersection

    public abstract R visitIntersection(IntersectionType t, P p)
    Visits an intersection type.
    Specified by:
      `visitIntersection` in interface `TypeVisitor<R,P>`
    Overrides:
      `visitIntersection` in class `AbstractTypeVisitor6<R,P>`
    Implementation Requirements:
      Visits an `IntersectionType` in a manner defined by a subclass.
    Parameters:
      `t` - the type to visit
      `p` - a visitor-specified parameter
    Returns:
      the result of the visit as defined by a subclass